/*
Author: Mike Bok
Email: freaknigh@hotmail.com
Website: www.nighsoft.net
License and Rights: Full licensing and Rights available at www.nighsoft.net.
If licensing and rights not available at www.nighsoft.net, then all the following apply as bulleted:
-all rights reserved.
-you can not modify source code in this file.
-you can compile and use this source code.
*/

#include "main.h"

void init_memory();

int main(int argc, char *argv[])
{
	if (!init_sdl()) return 0;
	init_memory();
	init_audio();
	load_splash_screen();
	load_login();
	read_host_info();
	read_config_info();
	connect_to_hub();
	handle_events();
	return 0;
}

void init_memory()
{
	int i,k;
	
	init_form_memory();
	set_trade_disaster_texts();
	clear_private_chat_entries();
	
	game.zone = 0;
	game.sector = 0;
	
	game.last_ldm[0] = 0;
	
	//start randomizer
	srand(time(0));
	
	for(i=0;i<10;i++)
	{
		game.ship[i].server_id = -1;
		game.ship[i].type = -1;
		game.ship[i].kind = -1;
		
		for(k=0;k<16;k++)
		{
		game.ship[i].gun[k] = -1;                
		game.ship[i].gun_id[k] = -1;
		game.ship[i].missile[k] = -1;                
		game.ship[i].missile_id[k] = -1;
		game.ship[i].misc[k] = -1;                
		game.ship[i].misc_id[k] = -1;
		}
	}
	
	//nif images
	game.nif_image.no_gun_pod = NULL;
	game.nif_image.no_missile_pod = NULL;
	game.nif_image.no_planet_img = NULL;
	game.nif_image.no_repair_img = NULL;
	game.nif_image.no_shop_img = NULL;
	game.nif_image.no_loc_img = NULL;
	game.nif_image.no_loc_safe_img = NULL;
	game.nif_image.no_loc_p_img = NULL;
	game.nif_image.no_hyper_p_img = NULL;
	
	//game images
	for(i=0;i<10;i++)
	{
		game.game_image.mini_good[i] = NULL;
		game.game_image.mini_contra[i] = NULL;
	}
	
	for(i=0;i<MAX_DECO;i++)
		game.game_image.deco_img[i] = NULL;
	
	for(i=0;i<EXP_RANK_IMG_MAX;i++)
		game.game_image.exp_rank[i] = NULL;
	
	game.game_image.guild_toggle_off = NULL;
	game.game_image.guild_toggle_on = NULL;
	game.game_image.fship_sat = NULL;
	game.game_image.fship_sat_destroyed = NULL;
}
